;
; G-KART OtBbN, 3DɊւTu[`
;
.include "gkart.h"

; R[X̕
CIRCUIT_WIDTH = 64

.area _CODE

;
; {ς
;
; 
; A:{
;
; o
; AF,BC,HL,IX:j
;
zoom::
	ld (#z), A
	or A
	jr Z, zoom_none

	ld IX, #zoom_table
	ld B, A
	add A
	add A
	add B
	add B
	ld B, #0
	ld C, A
	add IX, BC

	ld L, 0(IX)
	ld H, 1(IX)
	ld (#e_address), HL
	ld L, 2(IX)
	ld H, 3(IX)
	ld (#d_address), HL
	ld L, 4(IX)
	ld H, 5(IX)
	ld (#ay_address), HL
	ld (#ax_address), HL

	ld HL, #point0_zoom
	ld (#rotate_table1 + 0), HL
	ld HL, #point1_zoom
	ld (#rotate_table1 + 2), HL
	ld HL, #point2_zoom
	ld (#rotate_table1 + 4), HL
	ld HL, #point3_zoom
	ld (#rotate_table1 + 6), HL
	jr zoom_last

zoom_none:
	ld HL, #point0
	ld (#rotate_table1 + 0), HL
	ld HL, #point1
	ld (#rotate_table1 + 2), HL
	ld HL, #point2
	ld (#rotate_table1 + 4), HL
	ld HL, #point3
	ld (#rotate_table1 + 6), HL

zoom_last:
	ld A, (#r)

;
; J̊pxݒ肷
;
; 
; A:px
;
; o
; AF,BC:j
;
rotate::
	push HL

	ld (#r), A

	ld B, #0
	add #4

	; ϊ[`𓾂
	push AF
	rlca
	rlca
	rlca
	and #0x06
	ld C, A
	ld HL, #rotate_table1
	add HL, BC
	ld A, (HL)
	inc HL
	ld H, (HL)
	ld L, A
	ld (#point_address), HL
	pop AF

	; ϊe[u̐擪𓾂
	rrca
	rrca
	and #0x0e
	ld C, A
	ld HL, #rotate_table2
	add HL, BC
	ld A, (HL)
	inc HL
	ld H, (HL)
	ld L, A
	ld (#conv_table), HL

	pop HL
	ret

zoom_table:
	.dw div_e1, div_d1, div_a4
	.dw div_e2, div_d2, div_a2
	.dw div_e4, div_d4, mul_a1
	.dw div_e8, div_d8, mul_a2
	.dw div_e16, div_d16, mul_a4

rotate_table1:
	.dw point0
	.dw point1
	.dw point2
	.dw point3

rotate_table2:
	.dw conv_table0
	.dw conv_table1
	.dw conv_table2
	.dw conv_table3
	.dw conv_table4
	.dw conv_table5
	.dw conv_table6
	.dw conv_table7

;
; rn?
;
; 
; DE:Sʒu
;
; o
; NZ:rnłȂ, Z:rn
; AF,B,HL,AF':j
;
test_rough::
	; ւrn̏ォ?
	ld BC, #426 * 2 ; (10,18)
	call hit_test
	cp #0x80
	ret Z

	; Eւrn̏ォ?
	ld BC, #438 * 2 ; (13,18)
	call hit_test
	cp #0x80
	ret

;
; ǂɓ?
;
; 
; DE:Sʒu
;
; o
; NZ:ĂȂ, Z:
; AF,B,HL,AF':j
;
test_wall::
	; ޒ?
	ld A, (#v)
	rlca
	jr C, test_wall_skip

	; OւǂɓĂ邩?
	ld BC, #424 * 2 ; (10,16)
	call hit_test
	cp #0xc0
	ret Z

	; EOւǂɓĂ邩?
	ld BC, #436 * 2 ; (13,16)
	call hit_test
	cp #0xc0
	ret Z

test_wall_skip:
	; ւǂɓĂ邩?
	ld BC, #426 * 2 ; (10,18)
	call hit_test
	cp #0xc0
	ret Z

	; EւǂɓĂ邩?
	ld BC, #438 * 2 ; (13,18)
	call hit_test
	cp #0xc0
	ret

;
; ʂXV
;
; 
; DE:Sʒu
; IX:J[g̃p^[
;
; o
; AF,BC,HL,IX,AF':j
;
look::
	; VRAMANZX\ɂȂ܂ő҂
	in A, (#0x40)
	rlca
	jr C, look

	push IX

	; 1sڂ`
	ld HL, (#conv_table)
	ld IX, #pat_space
	ld A, #0xb0
	call putline

	; 2sڂ`
	ld A, #0xb1
	call putline

	; 3sڂ`
	ld IX, #pat_space
	ld A, #0xb2
	call putline

	pop IX

	; 4sڂ`
	ld A, #0xb3
	call putline

	; 5sڂ`
	ld A, #0xb4
	call putline

	; 6sڂ`
	ld IX, #pat_space
	ld A, #0xb5

;
; wi1s\ (look̉)
;
; 
; A:YW+0xb0
; DE:Sʒu
; HL:ϊe[ũAhX
; IX:J[g̃p^[̃AhX
;
; o
; HL:̕ϊe[ũAhX
; AF,BC,AF':j
;
putline:
	; YWݒ肷
	call sety

	; p^[1s\
	call putpat
	call putpat
	call putpat
	call putpat
	call putpat
	call putpat
	call putpat
	call putpat
	call putpat
	call putpat
	call putpat_kart
	call putpat_kart
	call putpat_kart
	call putpat_kart
	call putpat
	call putpat
	call putpat
	call putpat
	call putpat
	call putpat
	call putpat
	call putpat
	call putpat

;
; 4hbg\(J[gȂ) (putlinẻ)
;
; 
; DE:Sʒu
; HL:ϊ̃AhX
;
; o
; HL:̕ϊ̃AhX
; A,BC,AF':j
;
putpat:
	xor A
	ld BC, #0x0041
	call getpat
	call getpat
	call getpat
	call getpat

	out (C), B
	out (#0x41), A
	out (C), B
	out (#0x41), A
	out (C), B
	out (#0x41), A
	ret

;
; 4hbg\(J[g) (putlinẻ)
;
; 
; DE:Sʒu
; HL:ϊ̃AhX
; IX:J[g̃p^[̃AhX
;
; o
; HL:̕ϊ̃AhX
; IX:̃J[g̃p^[̃AhX
; A,BC,AF':j
;
putpat_kart:
	xor A
	ld B, A
	call getpat
	call getpat
	call getpat
	call getpat
	ld C, A

	ld A, B
	or 0(IX)
	out (#0x41), A
	ld A, C
	or 1(IX)
	out (#0x41), A
	ld A, B
	or 2(IX)
	out (#0x41), A
	ld A, C
	or 3(IX)
	out (#0x41), A
	ld A, B
	or 4(IX)
	out (#0x41), A
	ld A, C
	or 5(IX)
	out (#0x41), A

	ld BC, #6
	add IX, BC
	ret

;
; 蔻s (test_rough, test_wall̉)
;
; 
; BC:ʏ̈ʒu
; DE:Sʒu
;
; o
; A:0xc0=, 0x80=rn, 0x40=n, 0x00=n
; F,B,HL,AF':j
;
hit_test:
	ld HL, (#conv_table)
	add HL, BC
	xor A

;
; R[X̃p^[4hbg (putpat, putpat_kart̉)
;
; 
; DE:Sʒu
; HL:ϊ̃AhX
;
; o
; A:p^[(4hbg)
; B:Ep^[(4hbg)
; HL:̕ϊ̃AhX
; AF':j
;
getpat:
	ex AF, AF'
	push BC
	push DE

	; XW𓾂
	ld A, (HL)
	inc HL

	; YW𓾂
	ld C, (HL)
	inc HL

	; _邩ׂ
	.db 0xcd ; call
point_address:
	.dw point0

	pop DE
	pop BC

	; 擪1?
	jp C, getpat_on

; p^[0?
getpat_off:
	; 1?
	jp NZ, getpat_off_on

; p^[00
; 
; 
getpat_off_off:
	ex AF, AF'
	or A
	rra
	rra

	srl B
	srl B
	ret

; p^[01
; 
; 
getpat_off_on:
	ex AF, AF'
	or A
	rra
	rra

	scf
	rr B
	srl B
	ret

; p^[1?
getpat_on:
	; 擪1 1?
	jp NZ, getpat_on_on

; p^[10
; 
; 
getpat_on_off:
	ex AF, AF'
	or A
	rra
	scf
	rra

	scf
	rr B
	srl B
	ret

; p^[11
; 
; 
getpat_on_on:
	ex AF, AF'
	scf
	rra
	sra A

	scf
	rr B
	sra B
	ret

;
; _̗L𓾂 (getpat̉)
;
; 
; A:XW
; C:YW
; DE:Sʒu
;
; o
; NC:v[0_Ȃ, Cy:v[0_
; Z:v[1_Ȃ, NZ:v[1_
; A,BC,DE:j
;
; 90 <= r < 180
point1_zoom:
	; YW𓾂
	call point_zoom_y
	ld D, A

	; XW𓾂
	ld A, C
	neg
	call point_zoom_x
	ld E, A
	jp point

point_zoom_y:
	.db 0xcd ; call
d_address:
	.dw #div_d8
	add D
	.db 0xcd ; call
ay_address:
	.dw mul_a2
	cp #CIRCUIT_WIDTH
	ret C
	jr point_zoom_out

point_zoom_x:
	.db 0xcd ; call
e_address:
	.dw #div_e8
	add E
	.db 0xcd ; call
ax_address:
	.dw mul_a2
	cp #CIRCUIT_WIDTH
	ret C

point_zoom_out:
	pop DE
	ld DE, #0
	jp point

div_e16:
	srl E
div_e8:
	srl E
div_e4:
	srl E
div_e2:
	srl E
div_e1:
	ret

div_d16:
	srl d
div_d8:
	srl d
div_d4:
	srl d
div_d2:
	srl d
div_d1:
	ret

mul_a4:
	sla A
mul_a2:
	sla A
	ret
mul_a1:
	ret
div_a4:
	sra A
div_a2:
	sra A
	ret

point1:
	; YW𓾂
	add D
	sra A
	sra A
	ld D, A

	; XW𓾂
	ld A, C
	neg
	add E
	sra A
	sra A
	ld E, A
	jp point

; r < 90
point0_zoom:
	; YW𓾂
	call point_zoom_x
	ld E, A

	; XW𓾂
	ld A, C
	call point_zoom_y
	ld D, A
	jp point

point0:
	; YW𓾂
	add E
	sra A
	sra A
	ld E, A

	; XW𓾂
	ld A, C
	add D
	sra A
	sra A
	ld D, A
	jp point

; 270 <= r
point3_zoom:
	; YW𓾂
	neg
	call point_zoom_y
	ld D, A

	; XW𓾂
	ld A, C
	call point_zoom_x
	ld E, A
	jp point

point3:
	; YW𓾂
	neg
	add D
	sra A
	sra A
	ld D, A

	; XW𓾂
	ld A, C
	add E
	sra A
	sra A
	ld E, A
	jp point

; 180 <= r < 270
point2_zoom:
	; XW𓾂
	neg
	call point_zoom_x
	ld E, A

	; YW𓾂
	ld A, C
	neg
	call point_zoom_y
	ld D, A
	jp point

point2:
	; XW𓾂
	neg
	add E
	sra A
	sra A
	ld E, A

	; YW𓾂
	ld A, C
	neg
	add D
	sra A
	sra A
	ld D, A

;
; _̗L𓾂
;
; 
; DE:ʒu
;
; o
; NC:v[0_Ȃ, Cy:v[0_
; Z:v[1_Ȃ, NZ:v[1_
; A,BC,DE:j
;
point::
	push HL

	ld B, #0

	; }XN𓾂
	ld A, D
	and #0x07
	ld HL, #point_mask
	ld C, A
	add HL, BC
	ld A, (HL)
	push AF
	push AF

	; ItZbg𓾂
	; (YW)
	ld HL, #point_offset
	ld A, D
	and #0x3f
	add A
	ld C, A
	add HL, BC
	ld A, (HL)
	inc HL
	ld H, (HL)
	ld L, A
	; (XW)
	ld A, E
	and #0x3f
	ld E, A
	ld D, B
	add HL, DE

	; AhX𓾂 (v[0)
	ld DE, #circuit
	add HL, DE

	; _邩? (v[0)
	pop AF
	and (HL)

	ld DE, #CIRCUIT_WIDTH * 8
	jp NZ, point_on

point_off:
	; AhX𓾂 (v[1)
	add HL, DE

	; _邩? (v[1)
	pop AF
	and (HL)

	pop HL
	ret

point_on:
	; AhX𓾂 (v[1)
	add HL, DE

	; _邩? (v[1)
	pop AF
	and (HL)

	scf
	pop HL
	ret

point_offset:
	.dw CIRCUIT_WIDTH * 0
	.dw CIRCUIT_WIDTH * 0
	.dw CIRCUIT_WIDTH * 0
	.dw CIRCUIT_WIDTH * 0
	.dw CIRCUIT_WIDTH * 0
	.dw CIRCUIT_WIDTH * 0
	.dw CIRCUIT_WIDTH * 0
	.dw CIRCUIT_WIDTH * 0
	.dw CIRCUIT_WIDTH * 1
	.dw CIRCUIT_WIDTH * 1
	.dw CIRCUIT_WIDTH * 1
	.dw CIRCUIT_WIDTH * 1
	.dw CIRCUIT_WIDTH * 1
	.dw CIRCUIT_WIDTH * 1
	.dw CIRCUIT_WIDTH * 1
	.dw CIRCUIT_WIDTH * 1
	.dw CIRCUIT_WIDTH * 2
	.dw CIRCUIT_WIDTH * 2
	.dw CIRCUIT_WIDTH * 2
	.dw CIRCUIT_WIDTH * 2
	.dw CIRCUIT_WIDTH * 2
	.dw CIRCUIT_WIDTH * 2
	.dw CIRCUIT_WIDTH * 2
	.dw CIRCUIT_WIDTH * 2
	.dw CIRCUIT_WIDTH * 3
	.dw CIRCUIT_WIDTH * 3
	.dw CIRCUIT_WIDTH * 3
	.dw CIRCUIT_WIDTH * 3
	.dw CIRCUIT_WIDTH * 3
	.dw CIRCUIT_WIDTH * 3
	.dw CIRCUIT_WIDTH * 3
	.dw CIRCUIT_WIDTH * 3
	.dw CIRCUIT_WIDTH * 4
	.dw CIRCUIT_WIDTH * 4
	.dw CIRCUIT_WIDTH * 4
	.dw CIRCUIT_WIDTH * 4
	.dw CIRCUIT_WIDTH * 4
	.dw CIRCUIT_WIDTH * 4
	.dw CIRCUIT_WIDTH * 4
	.dw CIRCUIT_WIDTH * 4
	.dw CIRCUIT_WIDTH * 5
	.dw CIRCUIT_WIDTH * 5
	.dw CIRCUIT_WIDTH * 5
	.dw CIRCUIT_WIDTH * 5
	.dw CIRCUIT_WIDTH * 5
	.dw CIRCUIT_WIDTH * 5
	.dw CIRCUIT_WIDTH * 5
	.dw CIRCUIT_WIDTH * 5
	.dw CIRCUIT_WIDTH * 6
	.dw CIRCUIT_WIDTH * 6
	.dw CIRCUIT_WIDTH * 6
	.dw CIRCUIT_WIDTH * 6
	.dw CIRCUIT_WIDTH * 6
	.dw CIRCUIT_WIDTH * 6
	.dw CIRCUIT_WIDTH * 6
	.dw CIRCUIT_WIDTH * 6
	.dw CIRCUIT_WIDTH * 7
	.dw CIRCUIT_WIDTH * 7
	.dw CIRCUIT_WIDTH * 7
	.dw CIRCUIT_WIDTH * 7
	.dw CIRCUIT_WIDTH * 7
	.dw CIRCUIT_WIDTH * 7
	.dw CIRCUIT_WIDTH * 7
	.dw CIRCUIT_WIDTH * 7

pset_table:
	.db 0x80
point_mask:
	.db 0x01
	.db 0x02
	.db 0x04
	.db 0x08
	.db 0x10
	.db 0x20
	.db 0x40
	.db 0x80
	.db 0x01
	.db 0x02

;
; }bv\
;
; 
; DE:W
;
; o
; AF,BC,DE,HL:j
;
putmini::
	call setxy
	ld BC, #0x1041
	ld HL, #mini + 0
	in A, (#0x41)
	otir

	ld A, D
	add #8
	ld D, A
	call setxy
	ld BC, #0x1041
	ld HL, #mini + 16
	in A, (#0x41)
	otir
	ret

;
; ݈ʒu\
;
; 
; DE:ʒu
; HL:p^[̃AhX
; P:\, M:\Ȃ
;
; o
; AF,BC:j
; HL:̃p^[̃AhX
;
pset::
	ld A, D
	and #0x07
	ld C, A
	ld B, #0
	ld HL, #pset_table
	add HL, BC

	dec D
	call pset1
	inc D
	call pset1
	inc D

pset1:
	ld B, (HL)
	inc HL

	ret M

	push DE
	push HL

	ld HL, #pset_buf
	push BC
	push HL
	call setxy
	ld BC, #0x0341
	in A, (#0x41)
	inir
	pop HL
	pop BC

	call setxy
	ld A, B
	or (HL)
	out (#0x41), A
	inc HL

	ld A, B
	or (HL)
	out (#0x41), A
	inc HL

	ld A, B
	or (HL)
	out (#0x41), A

	pop HL
	pop DE
	ret

;
; Ԃ\
;
; 
; HL:
;
; o
; AF,BC,HL:j
;
puttime::
	call getmin
	call putchr
	ld A, #CHR_MINUTE
	call putchr
	call get10sec
	call putchr
	call get1sec
	call putchr
	ld A, #CHR_SECOND
	call putchr
	call get100msec
	call putchr
	ld A, L

;
; 1\
;
; 
; A:
;
; o
; BC:j
;
putchr::
	push HL

	ld HL, #pat_zero
	ld B, #0
	ld C, A
	add HL, BC
	add HL, BC
	add HL, BC
	ld BC, #0x0341
	otir
	xor A
	out (#0x41), A

	pop HL
	ret

;
; \
;
; 
; HL:̐擪AhX
;
; o
; HL:̕
; AF:j
;
putstr::
	ld A, (HL)
	inc HL
	inc A
	ret Z

	dec A
	call putchr
	jr putstr

;
; Ԃ𓾂()
;
; 
; HL:
;
; o
; A:()
; HL:c莞
;
getmin::
	ld BC, #6000
	jr getdig

;
; Ԃ𓾂(10b)
;
; 
; HL:
;
; o
; A:(10b)
; HL:c莞
;
get10sec::
	ld BC, #1000
	jr getdig

;
; Ԃ𓾂(1b)
;
; 
; HL:
;
; o
; A:(1b)
; HL:c莞
;
get1sec::
	ld BC, #100
	jr getdig

;
; Ԃ𓾂(100~b)
;
; 
; HL:
;
; o
; A:(100~b)
; HL:c莞
;
get100msec::
	ld BC, #10

;
; w肵ʂ̐𓾂
;
; 
; BC:
; HL:l
;
; 
; A:
; HL:c̒l
; F:j
;
getdig:
	xor A
getdig_loop:
	inc A
	or A
	sbc HL, BC
	jp NC, getdig_loop
	add HL, BC
	dec A
	ret

;
; ʂ
;
; 
; Ȃ
;
; o
; AF,BC,DE,HL:j
;
cls::
	ld A, #2
	call cls0
	xor A
	call cls0

	ld A, #0x40
	out (#0x40), A
	ret

cls0:
	ld (#0x790d), A
	ld DE, #0
	ld A, #" "
	ld B, #24 * 6
	jp 0xbfee


;
; \ʒuݒ肷 (YW)
;
; 
; A:YW+0xb0
;
; o
; AF:j
;
sety:
	; YWݒ肷
	out (#0x40), A

	; XW()ݒ肷
	xor A
	out (#0x40), A

	; XW()ݒ肷
	ld A, #0x10
	out (#0x40), A
	ret

;
; \ʒuݒ肷 (XYW)
;
; 
; DE:\ʒu
;
; o
; AF:j
;
setxy::
	; YWݒ肷
	ld A, D
	rrca
	rrca
	rrca
	and #0x07
	or #0xb0
	out (#0x40), A

	; XW()ݒ肷
	ld A, E
	and #0x0f
	out (#0x40), A

	; XW()ݒ肷
	ld A, E
	rrca
	rrca
	rrca
	rrca
	and #0x0f
	or #0x10
	out (#0x40), A
	ret

; 
text_title::
	.db CHR_3, CHR_D, CHR_SPACE, CHR_K, CHR_A, CHR_R, CHR_T, CHR_SPACE, CHR_R, CHR_A, CHR_C, CHR_1, CHR_N, CHR_G, CHR_SPACE, CHR_G, CHR_A, CHR_M, CHR_E, 0xff
text_no::
	.db CHR_N, CHR_0, CHR_PERIOD, 0xff
text_lap::
	.db CHR_L, CHR_A, CHR_P, CHR_COLON, 0xff
text_goal::
	.db CHR_G, CHR_0, CHR_A, CHR_L, CHR_EXCLAMATION, CHR_EXCLAMATION, CHR_EXCLAMATION, 0xff
text_retire::
	.db CHR_R, CHR_E, CHR_T, CHR_1, CHR_R, CHR_E, CHR_PERIOD2, 0xff
text_ready::
	.db CHR_R, CHR_E, CHR_A, CHR_D, CHR_Y, CHR_EXCLAMATION, 0xff
text_penalty::
	.db CHR_P, CHR_E, CHR_N, CHR_A, CHR_L, CHR_T, CHR_Y, 0xff
text_total::
	.db CHR_T, CHR_0, CHR_T, CHR_A, CHR_L, 0xff
text_newrec::
	.db CHR_N, CHR_E, CHR_W, CHR_R, CHR_E, CHR_C, CHR_EXCLAMATION, 0xff
text_strike::
	.db CHR_MINUS, CHR_MINUTE, CHR_MINUS, CHR_MINUS, CHR_SECOND, CHR_MINUS, CHR_MINUS, 0xff

; 󔒂̃p^[
pat_space::
	.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00

; {
z::
	.ds 1

; J̊px
r::
	.ds 1

.area _DATA

; _`掞̈ꎞ̈
pset_buf:
	.ds 3

; ϊe[u̐擪AhX
conv_table:
	.ds 2

;
; Copyright 2012 maruhiro
; All rights reserved. 
;
; Redistribution and use in source and binary forms, 
; with or without modification, are permitted provided that 
; the following conditions are met: 
;
;  1. Redistributions of source code must retain the above copyright notice, 
;     this list of conditions and the following disclaimer. 
;
;  2. Redistributions in binary form must reproduce the above copyright notice, 
;     this list of conditions and the following disclaimer in the documentation 
;     and/or other materials provided with the distribution. 
;
; THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, 
; INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
; FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
; THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
; SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
; PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
; WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
; OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
; ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
;

; eof
