;
; G-KART ^ɊւTu[`
;
.include "gkart.h"

.area _CODE

;
; ɉ]
;
; 
; Ȃ
;
; o
; A:px
; F,BC,HL:j
;
left::
	ld A, (#dir)
	dec A
	dec A
	jr setdir

;
; Eɉ]
;
; 
; Ȃ
;
; o
; A:px
; F,BC,HL:j
;
right::
	ld A, (#dir)
	inc A
	inc A

;
; pxݒ肷
;
; 
; A:px
;
; o
; A:px
; F,BC,HL:j
;
setdir::
	ld (#dir), A
	push AF

	push AF
	call sin
	pop AF
	ld (#uy), BC

	call cos
	ld (#ux), BC

	ld A, (#v)
	call setv

	pop AF
	ret

;
; xݒ肷
;
; 
; A:x
;
; o
; A:x
; Z:or Ǎ
; BC,HL:j
;
setv::
	ld (#v), A
	push AF

	push AF
	ld BC, (#uy)
	call mul_bc_a
	sra H
	rr L
	sra H
	rr L
	sra H
	rr L
	sra H
	rr L
	ld (#vy), HL
	pop AF

	ld BC, (#ux)
	call mul_bc_a
	sra H
	rr L
	sra H
	rr L
	sra H
	rr L
	sra H
	rr L
	ld (#vx), HL

	pop AF
	or A
	ret

;
; ʒuݒ肷
;
; 
; DE:ʒu
;
; o
; HL:j
;
setpos::
	ld L, #0x80
	ld H, D
	ld (#y16), HL
	ld (#old_y16), HL
	ld H, E
	ld (#x16), HL
	ld (#old_x16), HL
	ret

;
; 
;
; 
; Ȃ
;
; o
; A:1:S[ɒʂ, 0:ʂĂȂ, -1:tɒʂ
; Z:S[ʂĂȂ, NZ:S[ʂ
; DE:ʒu
; A,BC,HL:j
;
move::
	; YWɓ
	ld HL, (#y16)
	ld (#old_y16), HL
	ld BC, (#vy)
	add HL, BC
	ld (#y16), HL
	ld D, H

	; XWɓ
	ld HL, (#x16)
	ld (#old_x16), HL
	ld BC, (#vx)
	add HL, BC
	ld (#x16), HL
	ld E, H

	push DE

	; ړÖʒu𓾂
	ld A, (#old_y16 + 1)
	ld H, A
	ld A, (#old_x16 + 1)
	ld L, A

	; S[͍E܂͉ォ?
	ld BC, (#goal_rl)
	inc C
	dec C
	jr Z, move_skip_rl
	ex DE, HL
move_skip_rl:

	; S[͏c?
	inc B
	dec B
	jr Z, move_skip_horiz
	ld A, D
	ld D, E
	ld E, A
	ld A, H
	ld H, L
	ld L, A
move_skip_horiz:

	; YWS[͈̔͊O?
	ld BC, (#goal_y)
	ld A, D
	cp B
	jr C, move_nogoal
	cp C
	jr NC, move_nogoal

	; ړOYWS[͈̔͊O?
	ld A, H
	cp B
	jr C, move_nogoal
	cp C
	jr NC, move_nogoal

	; XWS[̉E?
	ld BC, (#goal_x)
	ld A, E
	cp C
	ld A, L
	jr NC, move_right

move_left:
	; ړOXWS[̉E?
	cp C
	jr C, move_nogoal

	; S[ʂ
	ld A, #1
	jr move_last

move_right:
	; ړOXWS[̍?
	cp C
	jr NC, move_nogoal

	; S[tɒʂ
	ld A, #-1
	jr move_last

move_nogoal:
	; S[ʂĂȂ
	xor A

move_last:
	pop DE
	or A
	ret

;
; HL = BC * A
;
; 
; A:l
; BC:l
;
; o
; HL:
; AF,BC:j
;
mul_bc_a::
	ld HL, #0

	or A
	ret Z

	jp P, mul_bc_a_skip2
	sbc HL, BC
	ld C, L
	ld B, H
	ld HL, #0
	neg
mul_bc_a_skip2:

mul_bc_a_loop:
	srl A
	jp NC, mul_bc_a_skip
	add HL, BC
	ret Z
mul_bc_a_skip:
	sla C
	rl B
	jp mul_bc_a_loop

;
; BC = cos(A)
;
; 
; A:px
;
; o
; BC:cos(A)
; AF,HL:j
;
cos::
	add #64

;
; BC = sin(A)
;
; 
; A:px
;
; o
; BC:sin(A)
; AF,HL:j
;
sin::
	; 180 <= r < 360 ?
	rlca
	push AF

	; 0 <= r < 90 ?
	srl A
	cp #0x40
	jp C, sin_skip1

	; 90 <= r < 180 ̂Ƃ r' = 180 - r Ƃ
	neg
	add #0x80
sin_skip1:

	; l𓾂
	ld B, #0
	ld C, A
	ld HL, #sin_table
	add HL, BC
	ld C, (HL)

	; 0 <= r < 180 ?
	pop AF
	ret NC

	; 0̂Ƃ߂
	inc C
	dec C
	ret Z

	; 180 <= r < 360̂Ƃɂ
	dec B
	ld A, C
	neg
	ld C, A
	ret

.area _DATA

; is
dir::
	.ds 1

; x(XJ[)
v::
	.ds 1

; cos(r)
uy:
	.ds 2

; sin(r)
ux:
	.ds 2

; Yx
vy:
	.ds 2

; Xx
vx:
	.ds 2

; YW
y16::
ylow:
	.ds 1
y::
	.ds 1

; XW
x16::
xlow:
	.ds 1
x::
	.ds 1

; ړOYW
old_y16::
	.ds 2

; ړOXW
old_x16::
	.ds 2

;
; Copyright 2012 maruhiro
; All rights reserved. 
;
; Redistribution and use in source and binary forms, 
; with or without modification, are permitted provided that 
; the following conditions are met: 
;
;  1. Redistributions of source code must retain the above copyright notice, 
;     this list of conditions and the following disclaimer. 
;
;  2. Redistributions in binary form must reproduce the above copyright notice, 
;     this list of conditions and the following disclaimer in the documentation 
;     and/or other materials provided with the distribution. 
;
; THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, 
; INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
; FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
; THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
; SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
; PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
; WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
; OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
; ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
;

; eof
